/**
* Copyright (c) 2020 The Nuinalp Authors. All rights reserved.
* Use of this source code is governed by a BSD-style license that can be
* found in the LICENSE file.
*/

@import '../../style/utils/animations';
@import '../../style/utils/sizes';

* {
  box-sizing: border-box;
}

::slotted nv-avatar {
  --background-color: var(--nv-theme-alt-1) !important;
}

.nv-separator {
  background-color: var(--nv-border-color);
  box-sizing: border-box;
  height: 1px;
  margin: 0 $space-default;
  width: 100%;
}

:host {
  @extend .transition-exit;
  cursor: pointer;
  display: inline-block;
  height: 42px;
  min-width: 150px;
  position: relative;
}

//
// Opened
//

:host(.nv-select-opened) {
  pointer-events: none;

  .nv-select-el {
    @extend .transition-exit;
    opacity: 0;
    pointer-events: none;
    transform: scale(1.1);
    visibility: hidden;
    z-index: 1;
  }
}

:host(.nv-select-closed) {
  .nv-select-el {
    @extend .transition-entrance;
    opacity: 1;
    transform: scale(1);
  }
}

:host(.nv-select-opening) {
  pointer-events: none;
}

//
// Disabled
//

:host(.nv-select-disabled) {
  cursor: not-allowed;
  opacity: 0.55;

  .nv-select-el {
    border-color: var(--nv-border-color);
  }
}

//
// Naked style
//

:host(.nv-select-naked) {
  .nv-select-el {
    background-color: transparent !important;
    border-color: transparent;
  }
}
  
.nv-select-el {
  align-items: center;
  background-color: var(--nv-theme-alt-2);
  border-bottom-color: var(--nv-border-color);
  border-bottom-style: solid;
  border-bottom-width: 2px;
  border-radius: 4px;
  display: flex;
  height: 42px;
  padding: $space-sm $space-default;
  position: relative;
  transition-property: boder-color, transform, opacity;

  .nv-select-icon {
    bottom: 12px;
    height: $space-sm;
    position: absolute;
    right: $space-default;
    width: $space-sm;

    path {
      fill: var(--nv-theme-primary);
    }
  }

  &:hover {
    @extend .transition-moviment;
    border-color: var(--nv-theme-primary);
  }
}

//
// Label
//

.nv-select-label,
.nv-select-selected-value {
  display: block;
  overflow: hidden;
  padding-right: 16px;
  pointer-events: none;
  text-overflow: ellipsis;
  user-select: none;
  white-space: nowrap;
  width: 100%;

  &:empty {
    display: none;
  }
}

.nv-select-label {
  color: var(--nv-type-secondary);
  font-family: 'FiraGO Italic';
}

.nv-select-label-active {
  font-size: 12px;
  height: auto;
  left: 0 !important;
  padding: 0 #{$space-default};
  pointer-events: none;
  position: absolute;
  top: -18px;
  transform: translateY(0%);
}

//
// Custom selected value
//

.nv-custom-selected-value {
  align-items: center;
  display: flex;
  height: 42px;
  left: 0;
  padding: $space-sm $space-default;
  position: absolute;
  top: 0;
  width: 100%;
}

:host(.nv-select-w-value) .nv-select-icon {
  bottom: 8px;
}

:host(.nv-select-w-label) {
  margin-top: $space-default;
}
